 CLS
   PRINT " FIXOPT v1.11"
   PRINT " ============"
   PRINT " Programme to read OPT file, and to check and/or fix:"
   PRINT "- fix face normals"
   PRINT "- texture scaling and rotation"
   PRINT
   PRINT "Set required graphic display using VIEW.BAS"
   PRINT
   PRINT "another humble offering by Lt Hag"
   PRINT "Please feel free to use this code and information to create new "
   PRINT "FREEWARE programs - and PLEASE send utilities and SOURCE CODE"
   PRINT "to the OPT project!"
   REM
   REM Updates this version:
   REM - Vertex normal fix (auto)
   REM - Tex vertex input (manual only) (I hope)

   REM Programme flow:
   REM Want Auto/manual?
   REM    Auto: Fix Normals? All/Mismatch? In/Out/Nearest?
   REM    Auto: Fix textures? All/NormalMismatchOnly? Scale?
   REM    Auto: Fix Min/Max?
   REM    Auto: Fix Vertex normals?
   REM
   REM    Manual: Stop at All/MismatchOnly?
   REM
   REM    Both: Start face No.?
   REM
   DIM STR AS STRING * 4000
   DIM COORD(1000) AS SINGLE
   DIM XYZ(333, 4) AS SINGLE
   DIM nodes(1300, 4)
   DIM TRIS(1500, 4) AS LONG
   DIM VNORMS(400, 4): REM XYZ face normals + no. of faces to average
   MAXVNORMS = 400
   DIM MIN(3), MAX(3), PNTS(3, 3), X(4), Y(4), Z(4), Texinf(6)
   DIM S1 AS STRING * 1
   DIM ST AS STRING * 7
   DIM SN AS STRING * 4
   DIM S4 AS STRING * 4
   DIM S2 AS STRING * 2
   DIM S24 AS STRING * 24
   DIM S12 AS STRING * 12
   DIM FACES AS STRING * 64
   DIM NORMSTR AS STRING * 12
   DIM normals(3)
   DIM FACENODES(16) AS LONG
   DIM MYST AS LONG
   DIM face(4, 3), MAXMIN(2, 3), VA(3), VB(3)
   DIM P1(3), P2(3), CN(3): REM CN is calculated face normal
   DIM EYE(3), SIGHT(3), TRANSMAT(4, 4)
   DIM TNODES(1300, 4)
   MAXNODES = 1300: MAXTRIS = 1500
   LASTCOL = 80: LASTROW = 30
   XPIXELS = 640: YPIXELS = 480: SMODE = 11
   PI = 3.1415927#
   NNODES = 0
   NTRIS = 0
   SMODE = 12
   NNSETS = 0
   NMM = 0
   N3000 = 0: N4000 = 0
   OPEN "VIEW.DAT" FOR INPUT AS #4
   OPEN "DEBUG.TXT" FOR OUTPUT AS #6

   FILES "*.opt"
   INPUT "Give OPT file to check:", PFILE$
   PRINT PFILE$
   OPEN PFILE$ FOR BINARY AS #9
   GET #9, 5, S4: REM Read recorded file length
   LSF = CVL(MID$(S4, 1, 4)) + 8
   PRINT "recorded OPT length="; LSF

99 REM INPUT "Want to set large-Z nodes to 0,0,0? (Y/N):", IMOD$
   REM IF IMOD$ <> "Y" AND IMOD$ <> "N" THEN GOTO 99
   REM IF IMOD$ = "Y" THEN INPUT "Give ZMAX for max. allowable Z:"; ZMAX

101 INPUT "Want to process automatically? (Y/N):", auto$
   IF auto$ <> "Y" AND auto$ <> "N" THEN GOTO 101
   REM

103 INPUT "Fix normals (Y/N):", NORMFIX$
   IF NORMFIX$ <> "Y" AND NORMFIX$ <> "N" THEN GOTO 103
   IF NORMFIX$ = "N" THEN GOTO 109
105 INPUT "Fix All or Mismatch only? (A/M):", WHICHN$
    IF WHICHN$ <> "A" AND WHICHN$ <> "M" THEN GOTO 105
    IF auto$ = "N" THEN GOTO 109
106 INPUT "Set to nearest Existing, pointing Out,In,Up or Down? (E/O/I/U/D):", NORMTYPE$
    IF NORMTYPE$ <> "E" AND NORMTYPE$ <> "O" AND NORMTYPE$ <> "I" AND NORMTYPE$ <> "U" AND NORMTYPE$ <> "D" THEN GOTO 106

109 INPUT "Fix textures (Y/N):", TEXFIX$
   IF TEXFIX$ <> "Y" AND TEXFIX$ <> "N" THEN GOTO 109
   IF TEXFIX$ = "N" THEN GOTO 114
110 INPUT "Fix ALL textures or normal Mismatch only? (A/M):", WHICHT$
   IF WHICHT$ <> "A" AND WHICHT$ <> "M" THEN GOTO 110
   IF WHICHT$ = "N" THEN GOTO 114
    IF auto$ = "N" THEN GOTO 114

112 INPUT "Give texture scale factor(=longest side fraction) (>0)"; TEXSCALE
    IF TEXSCALE <= 0 THEN GOTO 112

114 INPUT "Fix Max/min (hitzones)? (Y/N):", IMM$
    IF IMM$ <> "Y" AND IMM$ <> "N" THEN GOTO 114
   
116 INPUT "Fix Vertex Normals? (Y/N):", IVN$
    IF IVN$ <> "Y" AND IVN$ <> "N" THEN GOTO 116
  



120 INPUT "Give starting face#: ", SFACE
    IF SFACE <= 0 THEN GOTO 120

   REM Initialise

   SCREEN SMODE

    FOR I = 1 TO MAXNODES
130   FOR J = 1 TO 4
140     nodes(I, J) = 0
150   NEXT J
160 NEXT I

    FOR I = 1 TO MAXVNORMS
      FOR J = 1 TO 4
	VNORMS(I, J) = 0!
      NEXT J
    NEXT I


    REM Read view data
    FOR I = 1 TO 3
      MAX(I) = -1E+10: MIN(I) = 1E+10
    NEXT I
    INPUT #4, EYE(1), EYE(2), EYE(3)
    INPUT #4, SIGHT(1), SIGHT(2), SIGHT(3)
    PRINT "EYEPOINT  =", EYE(1), EYE(2), EYE(3)
    PRINT "SIGHTPOINT=", SIGHT(1), SIGHT(2), SIGHT(3)
    FOR I = 1 TO 4
      FOR J = 1 TO 4
	INPUT #4, TRANSMAT(I, J)
      NEXT J
    NEXT I
    INPUT #4, XWIN1, YWIN1, XWIN2, YWIN2
    PRINT "WINDOW=", XWIN1, YWIN1, XWIN2, YWIN2
    INPUT #4, P$: PRINT P$; : PRINT "-POINT PERSPECTIVE"
    INPUT #4, EYEANGLE: PRINT "EYE ANGLE=", EYEANGLE


    REM Scan OPT...

    REM Find next Node set, get no. of nodes in set NNSET , start, finish offsets
    PRINT
    PRINT "SCANNING OPT FILE..."
    SFPOS = 1
    NTRIS = 0
    NODESET = 0
    MMF = 0: NR = 0: REM initialise Flags to ensure have nodeset read before write min/max
    VNF = 0: NRV = 0: REM initialise Flags to ensure have nodeset read before write vertex normals
    NMM = 0: NVN = 0: REM counters for no. of 25 and 11 blocks read
    NNODES = 0: REM No. of OPT nodes
1520 REM Get next 4 bytes, starting at SFPOS
    GET #9, SFPOS, S4
     IF S4 = "Tex0" THEN GOTO 1530: REM found texture header
     REM In that case check for node header - longs 0,3,0,0
     MYST = CVL(MID$(S4, 1, 4))
     IF MYST = 0 THEN
	GET #9, SFPOS + 4, S4
	MYST1 = CVL(MID$(S4, 1, 4))
	IF MYST1 = 3 OR MYST1 = 25 OR MYST1 = 11 THEN
	   GET #9, SFPOS + 8, S4
	   MYST = CVL(MID$(S4, 1, 4))
	   IF MYST = 0 THEN
	     GET #9, SFPOS + 12, S4
	     MYST = CVL(MID$(S4, 1, 4))
	     IF MYST = 0 THEN
		REM Found nodes or XMIN/XMAXetc!!!
		IF MYST1 = 3 THEN
		   NR = 1: REM Flag nodes have been read. have to handle Min/Max occurring
				    REM NR = node read flag for MM, NRV= node read flag for VN
			   REM these blocks are sometimes before, sometimes after node set
		   SFPOS = SFPOS + 16
		   PRINT "NODES..."
		   NODESET = NODESET + 1
		   GOSUB 2100: REM set start/finish for nodes read
		   GOSUB 1100: REM read nodes triplets
		   GOSUB 1200: REM print to screen/file
		   IF IMOD$ = "Y" THEN GOSUB 2600: REM modify nodes if required
		   REM GOSUB 1900: REM transform nodes for screen display
		   REM INPUT "Pause..."; PAUSE$
		END IF
		IF MYST1 = 25 THEN
		   PRINT "Found MIN/MAX!"
		   NMM = NMM + 1
		   MMPOS = SFPOS
		   SFPOS = SFPOS + 16
		   MMF = 1: REM Flag found MIN / MAX
		   IF IMM$ = "Y" AND NR = 1 AND MMF = 1 THEN GOSUB 3000: REM check/fix max/min if required
		END IF
		IF MYST1 = 11 THEN
		   REM can only fix vector normals if nodes read, faces read and vector normals found
		   PRINT "Found VERTEX NORMALS!"
		   NVN = NVN + 1
		   VNPOS = SFPOS: REM mark vector normal location
		   SFPOS = SFPOS + 16
		   VNF = 1: REM Flag found Vector Normals
		END IF
		REM fix "extras" if everything needed is read or flagged
		IF IMM$ = "Y" AND NR = 1 AND MMF = 1 THEN GOSUB 3000: REM check/fix max/min if required
		IF IVN$ = "Y" AND NRV = 1 AND VNF = 1 THEN GOSUB 4000: REM Fix vector normals for prev. nodes if req'd
		
	     END IF
	   END IF
	END IF
     END IF


      SFPOS = SFPOS + 1
      IF SFPOS > LSF GOTO 1599
      GOTO 1520

1530 REM found a texture header!
    GET #9, SFPOS + 6, S2
    PRINT "Texture "; S2; "..."
       REM*************************************
       REM work out what follows now!
       REM Check first jump, the first 4 bytes after the null.
       FPOS = SFPOS + 9
       GET #9, FPOS, SN
       MYST = CVL(MID$(SN, 1, 4))
       A$ = HEX$(MYST)
       IF MYST = 0 THEN
	 REM OK, if next long = 1, face info follows, else skip to next texture
	 GET #9, FPOS + 4, SN
	 MYST = CVL(MID$(SN, 1, 4))
	 IF MYST = 1 THEN
	    REM found faces already, go to process them
	    GOTO 1550
	   ELSE
	     REM skip out, look for next texture flag
	     GOTO 1598
	 END IF
	END IF
	REM
	REM ok, must be a texture here. read size of it and skip it
	GET #9, SFPOS + 21, SN
	TEXSIZE = CVL(MID$(SN, 1, 4))
	PRINT "Texture found, size of Texture = "; TEXSIZE
	FPOS = SFPOS + 21 + 12 + TEXSIZE
	REM
	REM check new jump. If zero, face info follows
	GET #9, FPOS, SN
	MYST = CVL(MID$(SN, 1, 4))
	A$ = HEX$(MYST)
	IF MYST = 0 THEN GOTO 1550
	REM
	REM Still here? could be a new palette. skip if so and check again
	IF A$ = "CDCDCDCD" THEN
	    REM SKIP CD FILL AND PALETTE
	    FPOS = FPOS + 4096 + 8192
	    GET #9, FPOS, SN
	    MYST = CVL(MID$(SN, 1, 4))
	    A$ = HEX$(MYST)
	END IF
	REM
	REM check jump for 0 - if nothing this time, no faces.
	IF MYST = 0 THEN GOTO 1550
	    REM NO FACES! JUMP TO NEXT TEXTURE
	    PRINT "No faces this texture!"
	    PRINT "JUMP POINTER READ FROM OFFSET "; FPOS - 1
	    A$ = HEX$(MYST)
	    PRINT "JUMP POINTER :"; A$
	    SFPOS = FPOS - 1
	    GOTO 1598
	
1550    FACEPOS = FPOS + 16
	SFPOS = FPOS - 1
	REM
	REM OK, whether after texture or not, ready to read no. of
	REM faces from offset FACEPOS
	REM
	PRINT "# OF FACES OFFSET = "; FACEPOS - 1
	GET #9, FACEPOS, SN
	NFACES = CVL(MID$(SN, 1, 4))
	PRINT "No. of FACES = "; NFACES
	
	REM
	REM face nodes...
	PRINT "Face nodes:"
	FOR IN = 1 TO NFACES
	  CLS
	  FL = FACEPOS + 12 + (IN - 1) * 64
	  GET #9, FL, FACES
	  PRINT "face "; NTRIS; ",nodes are ";
	  FOR IND = 1 TO 16
	    FACENODES(IND) = CVL(MID$(FACES, 1 + (IND - 1) * 4, 4))
	    PRINT FACENODES(IND);
	    REM it's rough! but if we got it wrong, we'll be reading
	    REM from a random part of the file...
	    REM skip to resume scan if any of these node numbers is
	    REM <0 or > no. of nodes in set
	    IF IND <= 4 AND (FACENODES(IND) < -1 OR FACENODES(IND) > NNODES - 1) THEN
	      PRINT "!!Warning... illegal node no.s... skipping"
	      INPUT "Pause...", A$
	      GOTO 1598
	    END IF
	  NEXT IND
	  PRINT
	  NTRIS = NTRIS + 1
	  NRV = 1: REM Flag faces read, OK to calc vertex normals
	  REM PRINT "face "; NTRIS; ",nodes are ";
	  FOR IFN = 1 TO 4
	    TRIS(NTRIS, IFN) = PREVNODES + FACENODES(IFN) + 1: REM OPTs start node no.s at 0
	    REM PRINT TRIS(NTRIS, IFN);
	  NEXT IFN
	  REM TRIS(NTRIS, 5) = NODESET
	  REM PRINT TRIS(NTRIS, 5);
	  IF TRIS(NTRIS, 4) <= PREVNODES THEN TRIS(NTRIS, 4) = TRIS(NTRIS, 1): REM handles 3-node faces
	  PRINT
	  PRINT "FACE CO-ORDS:"
	  FOR J = 1 TO 4
	    X(J) = nodes(TRIS(NTRIS, J), 1)
	    Y(J) = nodes(TRIS(NTRIS, J), 2)
	    Z(J) = nodes(TRIS(NTRIS, J), 3)
	    PRINT J; X(J); Y(J); Z(J)
	  NEXT J

	REM
	REM -------------------------------------------------------------
	REM Load and check face normals, fix if requested:
	REM
	PRINT "face "; NTRIS; ",stored normals are ";
	  FL = FACEPOS + 12 + NFACES * 64 + (IN - 1) * 12
	  GET #9, FL, NORMSTR
	  FOR IND = 1 TO 3
	    normals(IND) = CVS(MID$(NORMSTR, 1 + (IND - 1) * 4, 4))
	    PRINT normals(IND);
	  NEXT IND
	  REM if not updating face normals or tex data, still add to tex vertex sum
	  IF NTRIS < SFACE THEN GOTO 1585: REM SFACE = start face

	  PRINT
	  REM
	  REM calc. normal for check :
	  REM
	  REM Load vertex coo-rds into FACES array, calculate max & min X,Y,Z
	  FOR J = 1 TO 3
	     MAXMIN(1, J) = 1000000!: MAXMIN(2, J) = -1000000!
	  NEXT J
	  FOR I = 1 TO 4
	     face(I, 1) = X(I): face(I, 2) = Y(I): face(I, 3) = Z(I)
	     FOR J = 1 TO 3
		IF face(I, J) < MAXMIN(1, J) THEN MAXMIN(1, J) = face(I, J)
		IF face(I, J) > MAXMIN(2, J) THEN MAXMIN(2, J) = face(I, J)
	     NEXT J
	  NEXT I
	  REM PRINT "xmin,xmax,ymin,ymax,zmin,zmax:";
	  REM FOR I = 1 TO 3: FOR J = 1 TO 2: PRINT MAXMIN(J, I); : NEXT J: NEXT I: PRINT
	  REM PRINT "XSPAN,YSPAN,ZSPAN:";
	  REM FOR I = 1 TO 3: PRINT MAXMIN(2, I) - MAXMIN(1, I); : NEXT I: PRINT
	  REM Get "Face Middle" AND face middle normal for "pointing outwards" calcs
	  XFM = (MAXMIN(1, 1) + MAXMIN(2, 1)) / 2: YFM = (MAXMIN(1, 2) + MAXMIN(2, 2)) / 2: ZFM = (MAXMIN(1, 3) + MAXMIN(2, 3)) / 2
	  FML = (XFM ^ 2 + YFM ^ 2 + ZFM ^ 2) ^ .5
	  IF FML = 0 THEN FML = 1: REM Handles null face
	  XFM = XFM / FML: YFM = YFM / FML: ZFM = ZFM / FML
	  REM
	  REM Find longest side LS and its length MAXLSL
		  LS = 0: MAXLSL = 0
		  FOR ILS = 1 TO 4
		    J = ILS + 1: IF ILS = 4 THEN J = 1: REM J is next face node
		    LSL = ((face(J, 1) - face(ILS, 1)) ^ 2 + (face(J, 2) - face(ILS, 2)) ^ 2 + (face(J, 3) - face(ILS, 3)) ^ 2) ^ .5
		    IF LSL > MAXLSL THEN MAXLSL = LSL: LS = ILS
		  NEXT ILS
		  REM PRINT "Longest side is "; LS; "Length="; MAXLSL
    
	  REM Get face normal vector as cross product of vectors from
	  REM points 1 to 2 (Vector A)  and 1 to 3 (Vector B)
	  a1 = X(2) - X(1): a2 = Y(2) - Y(1): a3 = Z(2) - Z(1)
	  b1 = X(3) - X(1): b2 = Y(3) - Y(1): b3 = Z(3) - Z(1)
	  XN = a2 * b3 - a3 * b2: YN = a3 * b1 - a1 * b3: ZN = a1 * b2 - a2 * b1

	  LENGTH = (XN * XN + YN * YN + ZN * ZN) ^ .5
	  REM PRINT "Calc'd normal:"; X; Y; Z
	  IF LENGTH = 0 THEN LENGTH = 1: REM handlescase when all nodes=0,0,0
	  XN = XN / LENGTH: YN = YN / LENGTH: ZN = ZN / LENGTH
	  PRINT "Calc'd normal vector:"; XN; YN; ZN

	  REM Now check length from calc'd to stored to
	  REM for both normal vectors i.e. incl. reversed
	  rx = -XN: ry = -YN: rz = -ZN: REM this is reverse normal vector
	  LEN1 = ((normals(1) - XN) ^ 2 + (normals(2) - YN) ^ 2 + (normals(3) - ZN) ^ 2) ^ .5
	  LENR = ((normals(1) - rx) ^ 2 + (normals(2) - ry) ^ 2 + (normals(3) - rz) ^ 2) ^ .5
	  ACC2 = .01
	  REM
	  REM Now decide what to do.
	  REM If not fixing normals at all, skip
	  REM If Mismatch fix only, check & skip if no mismatch
	  REM If Auto,
	  REM      set instructions according to E,I,O
	  REM
	  REM If Manual
	  REM      read instructions E,I,O,C,R
	  REM      (nearest exist, In, Out, Calc'd, Reversed)
	  REM
	  REM Then fix according to instructions
	  REM
	  REM skip if not fixing normals
	  IF NORMFIX$ = "N" THEN GOTO 1589
	  REM skip if mismatch faces only and no mismatch
	  IF WHICHN$ = "M" AND (LEN1 < ACC2 OR LENR < ACC2) THEN GOTO 1589
	 
	  REM skip questions if auto
	  IF auto$ = "Y" THEN GOTO 1570
	   
1555        REM Display model so far and face in question with normal on screen
	    GOSUB 2200: REM add 2 temporary nodes for face normal line
	    NNODES = NNODES + 2
	    GOSUB 1900: REM transform NNODES nodes for screen display
	    NNODES = NNODES - 2: REM delete 2 temporary nodes
	    REM INPUT "pAUSE...", A$
	    REM CLS
	    IF (LEN1 > ACC2 AND LENR > ACC2) THEN
		REM !!Stored normal not the same as Calculated normal!!
		PRINT "++++++++++++Face Normal mismatch!!++++++++++++++"
	    END IF
	    GOSUB 2000: REM draw model & face normal line
	 
	    REM Determine required action
1560        PRINT "(Calc'd normal direction displayed in red)"
	    INPUT "Fix with Nothing/nearest to Existing/In/Out/Calc'd/Reversecalc'd(N/E/I/O/C/R)?"; A$
	    IF A$ <> "N" AND A$ <> "E" AND A$ <> "I" AND A$ <> "O" AND A$ <> "C" AND A$ <> "R" THEN GOTO 1560
	    NORMTYPE$ = A$
	    IF NORMTYPE$ = "N" THEN GOTO 1589
	   
	    REM
1570        REM Set Normal to be written
	    
	    PRINT "Modifying normal..."
	   
	    IF NORMTYPE$ = "E" THEN
	      IF LEN1 < LENR THEN
		   normals(1) = XN: normals(2) = YN: normals(3) = ZN
		 ELSE
		   normals(1) = -XN: normals(2) = -YN: normals(3) = -ZN
	      END IF
	    END IF

	   
	    IF NORMTYPE$ = "C" THEN
		  normals(1) = XN: normals(2) = YN: normals(3) = ZN
	    END IF

	    IF NORMTYPE$ = "R" THEN
		  normals(1) = -XN: normals(2) = -YN: normals(3) = -ZN
	    END IF


	    IF NORMTYPE$ = "U" THEN
	       normals(1) = XN: normals(2) = YN: normals(3) = ZN
	       IF normals(3) < 0 THEN
		   normals(1) = -XN: normals(2) = -YN: normals(3) = -ZN
	       END IF
	    END IF

	    IF NORMTYPE$ = "D" THEN
	       normals(1) = XN: normals(2) = YN: normals(3) = ZN
	       IF normals(3) > 0 THEN
		   normals(1) = -XN: normals(2) = -YN: normals(3) = -ZN
	       END IF
	    END IF


		    
	
		 REM For O,I, Set normal to face away from origin i.e. "point out"
		 REM Calc lengths from origin to ends of the two normal vectors
		 REM Since in this case want BIGGER dist to be the normal used,
		 REM in this case LEN1 is length to reversed, LENR is length to calc'd
		 LEN1 = ((XFM - XN) ^ 2 + (YFM - YN) ^ 2 + (ZFM - ZN) ^ 2) ^ .5
		 LENR = ((XFM - rx) ^ 2 + (YFM - ry) ^ 2 + (ZFM - rz) ^ 2) ^ .5
		 IF NORMTYPE$ = "O" THEN
		    IF LEN1 < LENR THEN
		       normals(1) = XN: normals(2) = YN: normals(3) = ZN
		     ELSE
		       normals(1) = -XN: normals(2) = -YN: normals(3) = -ZN
		    END IF
		 END IF

	    IF NORMTYPE$ = "I" THEN
		 IF LEN1 > LENR THEN
		     normals(1) = XN: normals(2) = YN: normals(3) = ZN
		   ELSE
		     normals(1) = -XN: normals(2) = -YN: normals(3) = -ZN
		 END IF
	    END IF

1580        REM Put new normal back to OPT
	    REM add to vertex normal sum for averaging

	    CI = 0
	    PRINT : PRINT "Putting normals: ";
	    FOR I = 1 TO 9 STEP 4
	       CI = CI + 1
	       MID$(NORMSTR, I, 4) = MKS$(normals(CI))
	       PRINT normals(CI);
	    NEXT I
	    PUT #9, FL, NORMSTR

1585        REM add to Vertex normal sum...
	    REM PRINT "face "; NTRIS; ",nodes are ";
	    FOR IFN = 1 TO 4
	      FOR IFJ = 1 TO 3
		VNORMS(TRIS(NTRIS, IFN) - PREVNODES, IFJ) = VNORMS(TRIS(NTRIS, IFN) - PREVNODES, IFJ) + normals(IFJ)
		REM PRINT TRIS(NTRIS, IFN);
	      NEXT IFJ
	      VNORMS(TRIS(NTRIS, IFN) - PREVNODES, 4) = VNORMS(TRIS(NTRIS, IFN) - PREVNODES, 4) + 1
	    NEXT IFN

	   
1589      REM continue
	  REM ------------------------------------------------------------
	  REM Load and check texture scaling/rotation, update if req'd
	  IF NTRIS < SFACE THEN GOTO 1596: REM SFACE = start face
	  IF TEXFIX$ = "N" GOTO 1596
	  PRINT "=============================================="
	  PRINT "face "; NTRIS; ",Tex scaling/rotation info: "
	  FL = FACEPOS + 12 + NFACES * (64 + 12) + (IN - 1) * 24
	  GET #9, FL, S24
	  FOR IND = 1 TO 6
	    Texinf(IND) = CVS(MID$(S24, 1 + (IND - 1) * 4, 4))
	    PRINT Texinf(IND);
	  NEXT IND
	  PRINT

	  REM Get normal vector of Tex Vectors as cross product
	  REM to check texture "on-plane"
	  a1 = Texinf(1): a2 = Texinf(2): a3 = Texinf(3)
	  b1 = Texinf(4): b2 = Texinf(5): b3 = Texinf(6)
	  XT = a2 * b3 - a3 * b2: YT = a3 * b1 - a1 * b3: ZT = a1 * b2 - a2 * b1

	  LT = (XT * XT + YT * YT + ZT * ZT) ^ .5
	  IF LT = 0 THEN LT = 1: REM handles all nodes=0,0,0
	  XT = XT / LT: YT = YT / LT: ZT = ZT / LT
	  REM PRINT "Existing TEX normal :"; XT; YT; ZT
	  REM INPUT "Pause...", A$

	  REM Now check length from face normal to tex normal incl. reversed
	  RXT = -XT: RYT = -YT: RZT = -ZT
	  LEN1 = ((XT - XN) ^ 2 + (YT - YN) ^ 2 + (ZT - ZN) ^ 2) ^ .5
	  LENR = ((RXT - XN) ^ 2 + (RYT - YN) ^ 2 + (RZT - ZN) ^ 2) ^ .5
	  ACC2 = .01
	  REM
	  REM Again, decide what to do.
	  REM See procedure used for Normals.
	  REM If fixing Mismatch only and no mismatch, skip
	  IF LEN1 < ACC2 THEN PRINT "TEX NORMAL MATCHES FACE NORMAL!"
	  IF LENR < ACC2 THEN PRINT "TEX NORMAL MATCHES REVERSE FACE NORMAL!"
	  IF WHICHT$ = "M" AND (LEN1 < ACC2 OR LENR < ACC2) THEN GOTO 1596
	  PRINT "++++++++++++++++++++++++++++++++++++++++++++++++++"
	  IF LEN1 < ACC2 OR LENR < ACC2 THEN
	      PRINT "Fixing Tex info..."
	    ELSE
	      PRINT "+++++++++++++TEX Normal mismatch!!++++++++++++++"
	  END IF
	    IF auto$ = "N" THEN GOTO 1592: REM If not autofix, ask as usual
	    A$ = "C": REM set to use calc. scale on auto calc
	    GOTO 1594

1592        INPUT "Fix with Nothing/Samescale/CalcScale?(N/S/C)?"; A$
	    IF A$ <> "N" AND A$ <> "C" THEN GOTO 1592
	    IF A$ = "N" THEN GOTO 1596
1593        INPUT "Give texture scale factor(=longest side fraction) (>0)"; TEXSCALE
	    IF TEXSCALE <= 0 THEN GOTO 1593

1594        IF A$ = "N" THEN GOTO 1596
	    IF A$ = "C" THEN
1595              REM Set tex scale vectors onto plane, same size as before
		  REM choose to line up with longest side LS of length MAXLSL,
		  REM calc'd previously.
		  REM
		  
		  J = LS + 1: IF J = 5 THEN J = 1
		  LVX = face(J, 1) - face(LS, 1): LVY = face(J, 2) - face(LS, 2): LVZ = face(J, 3) - face(LS, 3)
		  PRINT "Longest Side Vector:"; LVX; LVY; LVZ
		  TL1 = (Texinf(1) ^ 2 + Texinf(2) ^ 2 + Texinf(3) ^ 2) ^ .5
		  TL2 = (Texinf(4) ^ 2 + Texinf(5) ^ 2 + Texinf(6) ^ 2) ^ .5
		  PRINT "Tex Lengths 1&2:"; TL1; TL2
		  Texinf(1) = LVX * TEXSCALE: Texinf(2) = LVY * TEXSCALE: Texinf(3) = LVZ * TEXSCALE
		  REM use Cross-product with Normal to get second direction
		  IF MAXLSL = 0 THEN MAXLSL = 1: REM Handles null face
		  a1 = LVX / MAXLSL: a2 = LVY / MAXLSL: a3 = LVZ / MAXLSL
		  b1 = normals(1): b2 = normals(2): b3 = normals(3)
		  XT2 = a2 * b3 - a3 * b2: YT2 = a3 * b1 - a1 * b3: ZT2 = a1 * b2 - a2 * b1
		  LT2 = (XT2 * XT2 + YT2 * YT2 + ZT2 * ZT2) ^ .5
		  REM if opposite dir'n to face normal, swap dir'n
		  REM IF (XN - XT2 / LT2) > ACC THEN
		     REM PRINT "swapping to opposite tex normal..."
		  REM END IF
		  PRINT "XT2,YT2,ZT2,LT2:"; XT2; YT2; ZT2; LT2
		  IF LT2 = 0 THEN LT2 = 1: REM Handles null face
		  Texinf(4) = XT2 / LT2 * MAXLSL * TEXSCALE: Texinf(5) = YT2 / LT2 * MAXLSL * TEXSCALE: Texinf(6) = ZT2 / LT2 * MAXLSL * TEXSCALE
	       ELSE
		  REM Attempt to calculate Text scales
		  REM Do nothing for now...
	    END IF
	    REM Put new Tex vectors back to OPT
	    CI = 0
	    PRINT : PRINT "Putting TEX data: ";
	    FOR I = 1 TO 21 STEP 4
	       CI = CI + 1
	       MID$(S24, I, 4) = MKS$(Texinf(CI))
	       PRINT Texinf(CI);
	    NEXT I
	    PRINT
	    REM
	    PUT #9, FL, S24
1596      REM Get side lengths, dot products
	  REM THIS STUFF ISN'T USED AT THE MOMENT
	  REM FOR I = 1 TO 4
	  REM   J = I + 1: IF I = 4 THEN J = 1: REM J is next face node
	  REM   K = I - 1: IF K = 0 THEN K = 4: REM K is previous face node
	  REM   LS = ((face(J, 1) - face(I, 1)) ^ 2 + (face(J, 2) - face(I, 2)) ^ 2 + (face(J, 3) - face(I, 3)) ^ 2) ^ .5
	  REM   REM PRINT "Side "; I; J; ", Length="; LS
	  REM   REM PRINT "Side Vector:";
	  REM   REM FOR IJ = 1 TO 3: PRINT FACE(J, IJ) - FACE(I, IJ); : NEXT IJ: PRINT
	  REM NEXT I
	  REM REM for each node, get dot products
	  REM FOR I = 1 TO 4
	  REM   J = I + 1: IF I = 4 THEN J = 1: REM J is next face node
	  REM   K = I - 1: IF K = 0 THEN K = 4: REM K is previous face node
	  REM   LS = ((face(J, 1) - face(I, 1)) ^ 2 + (face(J, 2) - face(I, 2)) ^ 2 + (face(J, 3) - face(I, 3)) ^ 2) ^ .5
	  REM   REM PRINT "Side "; I; J; ", Length="; LS
	  REM   REM PRINT "Side Vector:";
	  REM   REM FOR IJ = 1 TO 3: PRINT FACE(J, IJ) - FACE(I, IJ); : NEXT IJ: PRINT
	  REM   REM load vectors VA & VB from this point
	  REM   FOR IJ = 1 TO 3
	  REM      VA(IJ) = face(J, IJ) - face(I, IJ)
	  REM      VB(IJ) = face(K, IJ) - face(I, IJ)
	  REM   NEXT IJ
	  REM   REM DOT = VA(1) * VB(1) + VA(2) * VB(2) + VA(3) * VB(3)
	  REM   REM PRINT "dot product:"; DOT
	  REM   PRINT
	  REM
	  REM NEXT I

	  IF auto$ = "N" THEN INPUT "Pause...", A$
1597    NEXT IN
	
       
	REM Check link at end of face data
	FMPOS = FACEPOS + 12 + NFACES * 16 * 4 + NFACES * 3 * 4 + NFACES * 6 * 4
	GET #9, FMPOS, SN
	MYST = CVL(MID$(SN, 1, 4))
	A$ = HEX$(MYST)
	REM PRINT "Final Jump at offset "; FMPOS; ", jump bytes are "; A$

1598    REM GOSUB 2000
	REM IF S2 > "14" THEN GOSUB 2000
	PRINT
	SFPOS = SFPOS + 1
     GOTO 1520
1599 PRINT "NTRIS="; NTRIS
     REM Tidy up last lot of tex normals...
     REM IF IVN$ = "Y" AND VNF = 1 THEN GOSUB 4000: REM Fix vector normals for prev. nodes if req'd
     IF IVN$ = "Y" AND NRV = 1 AND VNF = 1 THEN GOSUB 4000: REM Fix vector normals for prev. nodes if req'd  



     REM All done! check had right number of nodes to reinsert :=)
     PRINT "NO. NODESETS,NO.MM, N3000="; NODESET; NMM; N3000
     PRINT : PRINT "==================================================="
     PRINT "No. of nodes found in OPT = "; NNODES
     PRINT : PRINT "==================================================="

     END



  

1100 REM Read triplets between START and FINISH
   LENGTH = FINISH - START + 1
   REM PRINT "Start = "; START
   REM PRINT "Finish= "; FINISH
   REM PRINT "Length in BYTES:"; LENGTH
   REM PRINT "Length in FLOAT:"; LENGTH / 4
   REM INPUT "Pause...:"; A$
   REM
   GET #9, START, STR: REM Read data
   REM
   REM----------------------------------------------------------------
    REM PRINT "ECHO:"
    CI = 0
    FOR I = 1 TO LENGTH STEP 4
       CI = CI + 1
       COORD(CI) = CVS(MID$(STR, I, 4))
       REM PRINT "COORD "; CI; " IS "; COORD(CI)
    NEXT I
    TNODES = CI / 3
    FOR IJK = 1 TO TNODES
       J = PREVNODES + IJK
       nodes(J, 1) = COORD((IJK - 1) * 3 + 1)
       nodes(J, 2) = COORD((IJK - 1) * 3 + 2)
       nodes(J, 3) = COORD((IJK - 1) * 3 + 3)
       nodes(J, 4) = 1
    NEXT IJK
    RETURN


1200 REM Print triplets to screen
     FOR IN = (PREVNODES + 1) TO NNODES
       PRINT IN; nodes(IN, 1); ","; nodes(IN, 2); ","; nodes(IN, 3)
     NEXT IN
     PRINT
     RETURN

1900 REM
    REM TRANSFORM NODES (only if node exists-4th col=1)
    REM
    FOR I = 1 TO NNODES
    REM IF (NODES(I, 4) = 0) THEN GOTO 1950
      FOR J = 1 TO 4
	TNODES(I, J) = 0
	FOR K = 1 TO 4
	  TNODES(I, J) = TNODES(I, J) + nodes(I, K) * TRANSMAT(K, J)
	NEXT K
      NEXT J
      FOR J = 1 TO 3
	TNODES(I, J) = TNODES(I, J) / TNODES(I, 4)
	IF TNODES(I, J) > MAX(J) THEN MAX(J) = TNODES(I, J)
	IF TNODES(I, J) < MIN(J) THEN MIN(J) = TNODES(I, J)
      NEXT J
1950 NEXT I
     RETURN

2000 REM
    REM draw on screen NTRIS tris
    WINDOW (XWIN1, YWIN1)-(XWIN2, YWIN2)
    REM
    REM DRAW TRIS
    REM
    COLOUR = 7
    FOR I = 1 TO NTRIS
    REM
      IF I = NTRIS THEN COLOUR = 2
      LINE (TNODES(TRIS(I, 1), 1), TNODES(TRIS(I, 1), 2))-(TNODES(TRIS(I, 2), 1), TNODES(TRIS(I, 2), 2)), COLOUR
      LINE (TNODES(TRIS(I, 2), 1), TNODES(TRIS(I, 2), 2))-(TNODES(TRIS(I, 3), 1), TNODES(TRIS(I, 3), 2)), COLOUR
      LINE (TNODES(TRIS(I, 3), 1), TNODES(TRIS(I, 3), 2))-(TNODES(TRIS(I, 4), 1), TNODES(TRIS(I, 4), 2)), COLOUR
      LINE (TNODES(TRIS(I, 4), 1), TNODES(TRIS(I, 4), 2))-(TNODES(TRIS(I, 1), 1), TNODES(TRIS(I, 1), 2)), COLOUR

    NEXT I
    REM draw cross on last face and normal line
      LINE (TNODES(TRIS(NTRIS, 1), 1), TNODES(TRIS(NTRIS, 1), 2))-(TNODES(TRIS(NTRIS, 3), 1), TNODES(TRIS(NTRIS, 3), 2)), 1
      LINE (TNODES(TRIS(NTRIS, 2), 1), TNODES(TRIS(NTRIS, 2), 2))-(TNODES(TRIS(NTRIS, 4), 1), TNODES(TRIS(NTRIS, 4), 2)), 1
      LINE (TNODES(NNODES + 1, 1), TNODES(NNODES + 1, 2))-(TNODES(NNODES + 2, 1), TNODES(NNODES + 2, 2)), 4

    SIDE = (XWIN2 - XWIN1) / 20
    LINE (XWIN2, YWIN2)-(XWIN2 - SIDE, YWIN2)
    LINE (XWIN2 - SIDE, YWIN2)-(XWIN2 - SIDE, YWIN2 - SIDE)
    LINE (XWIN2 - SIDE, YWIN2 - SIDE)-(XWIN2, YWIN2 - SIDE)
    LINE (XWIN2, YWIN2 - SIDE)-(XWIN2, YWIN2)
    REM LOCATE LASTROW, LASTCOL - 10: REM INPUT "PAUSE...", ANS$
    RETURN



2100 REM Set start and finish to read nodes
    GET #9, SFPOS, S4: REM Read no. of nodes
    PREVNODES = NNODES
    NNSET = CVL(MID$(S4, 1, 4))
    PRINT "No. of nodes this node set = "; NNSET
    NNODES = NNSET + PREVNODES
    PRINT "TOTAL No. of OPT nodes so far = "; NNODES
    REM INPUT "Pause..."; a$
    START = SFPOS + 8
    FINISH = START + NNSET * 3 * 4 - 1
    RETURN

2200 REM Create 2 temporary new nodes for normal arrow
    CN(1) = XN: CN(2) = YN: CN(3) = ZN: REM calculated normals
    FOR J = 1 TO 3: nodes(NNODES + 1, J) = (face(1, J) + face(3, J)) / 2: NEXT J: REM base of arrow
    FOR J = 1 TO 3: nodes(NNODES + 2, J) = nodes(NNODES + 1, J) + CN(J) * MAXLSL / 2: NEXT J: REM top of arrow
    nodes(NNODES + 1, 4) = 1: nodes(NNODES + 2, 4) = 1
    REM INPUT "pause..."; a$
    RETURN
    

2600 REM
    REM Put appropriate nodes for this set into XYZ
    PNODES = NNODES - NNSET: REM no. of nodes previously written
    FOR I = 1 TO NNSET
      INODE = I + PNODES
      IF nodes(INODE, 3) > ZMAX THEN PRINT "!!! setting node to origin, node "; INODE
      FOR J = 1 TO 3
	IF nodes(INODE, 3) > ZMAX THEN nodes(INODE, J) = 0
	XYZ(I, J) = nodes(INODE, J)
      NEXT J
    NEXT I
    REM Put triplets back into single line
    REM Skip nodes not set = not called up in a face
    FOR J = 1 TO NNSET
       REM IF XYZ(J, 4) <> 1 GOTO 2610
       COORD((J - 1) * 3 + 1) = XYZ(J, 1)
       COORD((J - 1) * 3 + 2) = XYZ(J, 2)
       COORD((J - 1) * 3 + 3) = XYZ(J, 3)
2610 NEXT J
    REM reconvert to string and put back to file
    CI = 0
    FOR I = 1 TO LENGTH STEP 4
       CI = CI + 1
       MID$(STR, I, 4) = MKS$(COORD(CI))
       PRINT "COORD "; CI; " IS "; COORD(CI)
    NEXT I
    INPUT "Pause... about to reinsert nodes...", A$
    PUT #9, START, STR
    RETURN

3000 REM Read and check XMIN etc for this nodeset
     N3000 = N3000 + 1
     START = MMPOS + 56
     FINISH = START + 6 * 4 - 1
     LENGTH = FINISH - START + 1
     REM
     GET #9, START, STR: REM Read data
     PRINT "read from offset "; START - 1
     PRINT "Current Xmin,Ymin,Zmin,Xmax,Ymax,Zmax:"
     CI = 0
     FOR I = 1 TO LENGTH STEP 4
	CI = CI + 1
	COORD(CI) = CVS(MID$(STR, I, 4))
	PRINT COORD(CI);
     NEXT I
     PRINT

	  REM
	  REM calculate max & min X,Y,Z for this nodeset
	  FOR J = 1 TO 3
	     MAXMIN(1, J) = 1000000!: MAXMIN(2, J) = -1000000!
	  NEXT J
	  FOR I = 1 TO NNSET
	     IN = I + PREVNODES
	     FOR J = 1 TO 3
		IF nodes(IN, J) < MAXMIN(1, J) THEN MAXMIN(1, J) = nodes(IN, J)
		IF nodes(IN, J) > MAXMIN(2, J) THEN MAXMIN(2, J) = nodes(IN, J)
	     NEXT J
	  NEXT I
	  PRINT "Calc'd xmin,ymin,zmin,xmax,ymax,zmax:"
	  IJ = 0
	  FOR I = 1 TO 2
	     FOR J = 1 TO 3
		PRINT MAXMIN(I, J);
		IJ = IJ + 1
		COORD(IJ) = MAXMIN(I, J)
	     NEXT J
	  NEXT I
	  PRINT
3010      REM INPUT "OK to insert?...", A$
	  REM IF A$ <> "Y" AND A$ <> "N" THEN GOTO 3010
	  REM IF A$ = "N" THEN GOTO 3020
	 
	  REM reconvert to string and put back to file
	  CI = 0
	  FOR I = 1 TO LENGTH STEP 4
	     CI = CI + 1
	     MID$(S24, I, 4) = MKS$(COORD(CI))
	     REM PRINT "COORD "; CI; " IS "; COORD(CI)
	  NEXT I
	  PUT #9, START, S24
3020     REM Continue
    
     REM Check mid-span entries
     START = MMPOS + 44
     FINISH = START + 3 * 4 - 1
     LENGTH = FINISH - START + 1
     REM
     GET #9, START, STR: REM Read data
     PRINT "XYZ mid-span info read from offset "; START - 1
     PRINT "Current Xmid,Ymid,Zmid:"
     CI = 0
     FOR I = 1 TO LENGTH STEP 4
	CI = CI + 1
	COORD(CI) = CVS(MID$(STR, I, 4))
	PRINT COORD(CI);
     NEXT I
     PRINT
     PRINT "Calc'd Xmid,Ymid,Zmid:"
     FOR IK = 1 TO 3: PRINT (MAXMIN(2, IK) + MAXMIN(1, IK)) / 2; : NEXT IK: PRINT
     REM INPUT "Pause..."; AN$
	  REM Update, reconvert to string and put back to file
	  IJ = 0
	  FOR J = 1 TO 3
	      IJ = IJ + 1
	      COORD(IJ) = (MAXMIN(1, J) + MAXMIN(2, J)) / 2
	  NEXT J
	 
	  CI = 0
	  FOR I = 1 TO LENGTH STEP 4
	     CI = CI + 1
	     MID$(S12, I, 4) = MKS$(COORD(CI))
	     REM PRINT "COORD "; CI; " IS "; COORD(CI)
	  NEXT I
	  PUT #9, START, S12


     REM Check XYZ span entries
     START = MMPOS + 32
     FINISH = START + 3 * 4 - 1
     LENGTH = FINISH - START + 1
     REM
     GET #9, START, STR: REM Read data
     PRINT "XYZ span info read from offset "; START - 1
     PRINT "Current Xspan,Yspan,Zspan:"
     CI = 0
     FOR I = 1 TO LENGTH STEP 4
	CI = CI + 1
	COORD(CI) = CVS(MID$(STR, I, 4))
	PRINT COORD(CI);
     NEXT I
     PRINT
     PRINT "Calc'd Xspan,Yspan,Zspan:"
     FOR IK = 1 TO 3: PRINT (MAXMIN(2, IK) - MAXMIN(1, IK)); : NEXT IK: PRINT
     REM INPUT "Pause..."; AN$
	  REM Update, reconvert to string and put back to file
	  IJ = 0
	  FOR J = 1 TO 3
	      IJ = IJ + 1
	      COORD(IJ) = MAXMIN(2, J) - MAXMIN(1, J)
	  NEXT J

	  CI = 0
	  FOR I = 1 TO LENGTH STEP 4
	     CI = CI + 1
	     MID$(S12, I, 4) = MKS$(COORD(CI))
	     REM PRINT "COORD "; CI; " IS "; COORD(CI)
	  NEXT I
	  PUT #9, START, S12


	 MMF = 0: REM Flag this Min/Max has been used, need new one for next nodeset
	 NR = 0: REM Flag this nodeset has been used for min/max calcs too
       RETURN

4000 REM
     N4000 = N4000 + 1
     START = VNPOS + 16
     GET #9, START, S4: REM Read No. of vert. normals
     NVN = CVL(MID$(S4, 1, 4))

     REM now read existing vertex normals
     START = VNPOS + 24
     FINISH = START + NVN * 3 * 4 - 1
     LENGTH = FINISH - START + 1
     REM
     GET #9, START, STR: REM Read data
     PRINT "read from offset "; START - 1
     PRINT "Current Vertex normals:"
     PRINT #6, "Current Vertex normals:"
     PRINT #6, "read from offset "; START - 1
     INPUT "Pause..."; A$
     FOR IN = 1 TO NVN
       PRINT "VN for vertex "; IN; " is ";
       FOR JN = 1 TO 3
	 I = ((IN - 1) * 3 + JN - 1) * 4 + 1
	 VNC = CVS(MID$(STR, I, 4)): PRINT VNC; : PRINT #6, VNC;
	 COORD((IN - 1) + JN) = VNC
       NEXT JN
       PRINT : PRINT #6, ""
     NEXT IN
     INPUT "Pause..."; A$

     PRINT "Calc'd vertex normals:"
     PRINT #6, "Calc'd vertex normals:"
     FOR I = 1 TO NVN
       IF VNORMS(I, 4) = 0 THEN VNORMS(I, 4) = 1
       FOR J = 1 TO 3
	 VNORMS(I, J) = VNORMS(I, J) / VNORMS(I, 4)
	 PRINT VNORMS(I, J);
	 PRINT #6, VNORMS(I, J);
       NEXT J
       PRINT : PRINT #6, ""
     NEXT I
     INPUT "Pause..."; A$

     FOR IN = 1 TO NVN
       FOR JN = 1 TO 3
	 I = ((IN - 1) * 3 + JN - 1) * 4 + 1
	 MID$(STR, I, 4) = MKS$(VNORMS(IN, JN))
       NEXT JN
     NEXT IN
     PUT #9, START, STR



    VNF = 0: REM reset vertex normals found flag
    NRV = 0: REM flag have used these nodes for vertex normals
    
    FOR I = 1 TO MAXVNORMS
      FOR J = 1 TO 4
	VNORMS(I, J) = 0!
      NEXT J
    NEXT I

    RETURN

