   CLS
   PRINT " OPTDXF v1.3"
   PRINT " ==========="
   PRINT " Programme to read nodes and face data from input .OPT file and"
   PRINT " write to DXF file, with draw on screen for debug."
   REM Updates this version:
   REM - Array size increases to handle more models
   REM - ROUGH check to skip incorrectly detected faces, gives warning.
   REM   (now works for ASSAULT.OPT and others). Please report to me
   REM   for which OPTs you encounter this warning.
   REM - Progressive display now starts at input face#, and last face is
   REM   displayed in blue with a green cross on diagonals. Use to determine
   REM   face no.s for Texture fixes, <cntrl-Break> to abort if too slow.
   REM   Start at 1 displays all faces, 99999 displays none. Remark out
   REM   and set DISPFACE permanently if this not required.
   REM
   REM Known limitations:
   REM - won't handle structure irregularities in PLATFORM opts
   REM FAQ
   REM - can't see model display? check eyepoint & sightpoint!
   REM - overflow on display? set eyepoint further from model.
   REM
20 REM  Eyepoint,sightpoint,transform matrix, perspective (2/3 point) and
30 REM  eye angle are read from VIEW.DAT.
   REM  Use VIEW.BAS to create VIEW.DAT
   REM
   PRINT "another humble offering by Lt Hag"
   PRINT "Please feel free to use this code and information to create new "
   PRINT "FREEWARE programs - and PLEASE send utilities and SOURCE CODE"
   PRINT "to the OPT project!"
40 REM
   DIM S1 AS STRING * 1
   DIM ST AS STRING * 7
   DIM SN AS STRING * 4
   DIM S4 AS STRING * 4
   DIM S2 AS STRING * 2
   DIM FACES AS STRING * 64
   DIM STR AS STRING * 4000
   DIM COORD(1000) AS SINGLE
   DIM FACENODES(16) AS LONG
   DIM MYST AS LONG
   DIM PNTS(3, 4), P1(3), P2(3)
   DIM EYE(3), SIGHT(3), NODES(2000, 4), TRANSMAT(4, 4)
   DIM TRIS(2000, 5) AS INTEGER: REM 4 face nodes, + Tex#
   DIM TNODES(2000, 4), MIN(3), MAX(3)
   MAXNODES = 2000: MAXTRIS = 2000

42 LASTROW = 30: LASTCOL = 80
43 SMODE = 12
44 REM INPUT "SCREEN MODE="; SMODE
45 REM
50 OPEN "VIEW.DAT" FOR INPUT AS #4
   FILES "*.DAT": FILES "*.TXT": FILES "*.OPT"
   PRINT "OPTDXF - convert opt file to DXF file"
   INPUT "Give OPT file name for processing (incl ext'n):", PFILE$
   PRINT PFILE$
   OPEN PFILE$ FOR BINARY AS #9
   GET #9, 5, S4: REM Read recorded file length
   LSF = CVL(MID$(S4, 1, 4)) + 8
   PRINT "OPT length="; LSF

   REM
   OPEN "BASEDXF.DXF" FOR INPUT AS #3
   INPUT "GIVE OUTPUT FILE(INCL. DXF EXT'N)? ", O$
   OPEN O$ FOR OUTPUT AS #1
   
   INPUT "Start display at face#:"; DISPFACE
   REM DISPFACE = 9999: REM No progressive display - use for debug if necessary

   DZ = 1E-10
   REM
   REM Read DXF headers from std file, write to new DXF file
   REM
75 IF EOF(3) THEN GOTO 76
   INPUT #3, A$
   PRINT #1, A$
   GOTO 75
76 REM CONTINUE

100 FOR I = 1 TO MAXNODES
110   FOR J = 1 TO 4
120     NODES(I, J) = 0
130   NEXT J
140 NEXT I
150 NNODES = 0: NTRIS = 0
160 FOR I = 1 TO 3
170   MAX(I) = -1E+10: MIN(I) = 1E+10
180 NEXT I
190 INPUT #4, EYE(1), EYE(2), EYE(3)
200 INPUT #4, SIGHT(1), SIGHT(2), SIGHT(3)
210 PRINT "EYEPOINT  =", EYE(1), EYE(2), EYE(3)
220 PRINT "SIGHTPOINT=", SIGHT(1), SIGHT(2), SIGHT(3)
230 FOR I = 1 TO 4
240   FOR J = 1 TO 4
250     INPUT #4, TRANSMAT(I, J)
260   NEXT J
270 NEXT I
280 INPUT #4, XWIN1, YWIN1, XWIN2, YWIN2
290 PRINT "WINDOW=", XWIN1, YWIN1, XWIN2, YWIN2
295 INPUT #4, P$: PRINT P$; : PRINT "-POINT PERSPECTIVE"
297 INPUT #4, EYEANGLE: PRINT "EYE ANGLE=", EYEANGLE

300 REM=====================================================================
310 REM INPUT DATA FROM FILE
    REM
    NNODES = 0
    NNSETS = 0
    GOSUB 1500
    REM INPUT "Pause...", PAUSE$
    GOSUB 1300
    REM INPUT "Pause...", PAUSE$
    REM
    REM=======================================================================
    REM
560 SCREEN SMODE
570 WINDOW (XWIN1, YWIN1)-(XWIN2, YWIN2)
700 REM
710 REM DRAW TRIS & WRITE TO DXF FILE
720 REM
730 FOR I = 1 TO NTRIS
    REM
    REM Load face vertices into array "PNTS"
    REM
    FOR IP = 1 TO 4
      FOR IC = 1 TO 3
        PNTS(IC, IP) = NODES(TRIS(I, IP), IC)
      NEXT IC
    NEXT IP
    REM
    REM Print triangle to DXF file
    REM
    PRINT #1, "3DFACE": PRINT #1, " 8": PRINT #1, "2": REM 2=layer
    REM PRINT #1, " 6" :PRINT #1, "CONTINUOUS": PRINT #1, "62": PRINT #1, " 130"
    REM PRINT "PRINTING FACE:"
    FOR IV = 0 TO 3
      J = IV + 1: REM IF IV = 3 THEN J = 1
      REM PRINT "FOR VERTEX:", J
      FOR K = 1 TO 3
         L = K
         PRINT #1, USING "#"; K; IV
         REM PRINT "FOR POINT HEADED BY:";
         REM PRINT USING "#"; K; IV
         PRINT #1, PNTS(L, J)
       NEXT K
    NEXT IV
    PRINT #1, "0"
770 NEXT I
    PRINT #1, "ENDSEC": PRINT #1, " 0": PRINT #1, "EOF"
830 CLOSE
    PRINT "NO. OF NODE SETS ="; NODESET
    INPUT "Give TRIS file (incl. ext'n):"; A$
    OPEN A$ FOR OUTPUT AS #1
    REM Print face nodes to file
    PRINT #1, NTRIS
    FOR IT = 1 TO NTRIS
       PRINT #1, TRIS(IT, 1); ","; TRIS(IT, 2); ","; TRIS(IT, 3); ","; TRIS(IT, 4)
    NEXT IT
    CLOSE
835 GOSUB 2000: REM Draw complete model
840 REM CHAIN "C:\PROGS\SURFACE"
850 END


1100 REM Read triplets between START and FINISH
   LENGTH = FINISH - START + 1
   REM PRINT "Start = "; START
   REM PRINT "Finish= "; FINISH
   REM PRINT "Length in BYTES:"; LENGTH
   REM PRINT "Length in FLOAT:"; LENGTH / 4
   REM INPUT "Pause...:"; A$
   REM
   GET #9, START, STR: REM Read data
   REM
   REM----------------------------------------------------------------
    REM PRINT "ECHO:"
    CI = 0
    FOR I = 1 TO LENGTH STEP 4
       CI = CI + 1
       COORD(CI) = CVS(MID$(STR, I, 4))
       REM PRINT "COORD "; CI; " IS "; COORD(CI)
    NEXT I
    TNODES = CI / 3
    FOR IJK = 1 TO TNODES
       J = PREVNODES + IJK
       NODES(J, 1) = COORD((IJK - 1) * 3 + 1)
       NODES(J, 2) = COORD((IJK - 1) * 3 + 2)
       NODES(J, 3) = COORD((IJK - 1) * 3 + 3)
       NODES(J, 4) = 1
    NEXT IJK
    RETURN


1200 REM Print triplets to screen
     FOR IN = (PREVNODES + 1) TO NNODES
       PRINT IN; NODES(IN, 1); ","; NODES(IN, 2); ","; NODES(IN, 3)
     NEXT IN
     PRINT
     RETURN


1300 REM Print face nodes to screen
     FOR IT = 1 TO NTRIS
       PRINT TRIS(IT, 1); ","; TRIS(IT, 2); ","; TRIS(IT, 3); ","; TRIS(IT, 4)
     NEXT IT
     PRINT
     RETURN



REM Step through file, reading nodes/faces along the way...

1500 REM Set start and finish to read texture data for each texture
    PRINT
    PRINT "SCANNING OPT FILE..."
    SFPOS = 1
    NTRIS = 0
    NODESET = 0
1520 REM Get next 4 bytes, starting at SFPOS
     GET #9, SFPOS, S4
     IF S4 = "Tex0" THEN GOTO 1530: REM found texture header
     REM In that case check for node header - longs 0,3,0,0
     MYST = CVL(MID$(S4, 1, 4))
     IF MYST = 0 THEN
        GET #9, SFPOS + 4, S4
        MYST = CVL(MID$(S4, 1, 4))
        IF MYST = 3 THEN
           GET #9, SFPOS + 8, S4
           MYST = CVL(MID$(S4, 1, 4))
           IF MYST = 0 THEN
             GET #9, SFPOS + 12, S4
             MYST = CVL(MID$(S4, 1, 4))
             IF MYST = 0 THEN
                REM Found nodes!!
                SFPOS = SFPOS + 16
                PRINT "NODES..."
                NODESET = NODESET + 1
                GOSUB 2100: REM set start/finish for nodes read
                GOSUB 1100: REM read nodes triplets
                GOSUB 1200: REM print to screen/file
                GOSUB 1900: REM transform nodes for screen display
                IF NTRIS >= DISPFACE THEN INPUT "Pause..."; PAUSE$
             END IF
           END IF
        END IF
     END IF


      SFPOS = SFPOS + 1
      IF SFPOS > LSF GOTO 1599
      GOTO 1520

1530 REM found a texture header!
    GET #9, SFPOS + 6, S2
    CLS
    PRINT "Texture "; S2; "..."
       REM*************************************
       REM work out what follows now!
       REM Check first jump, the first 4 bytes after the null.
       FPOS = SFPOS + 9
       GET #9, FPOS, SN
       MYST = CVL(MID$(SN, 1, 4))
       A$ = HEX$(MYST)
       IF MYST = 0 THEN
         REM OK, if next long = 1, face info follows, else skip to next texture
         GET #9, FPOS + 4, SN
         MYST = CVL(MID$(SN, 1, 4))
         IF MYST = 1 THEN
            REM found faces already, go to process them
            GOTO 1550
           ELSE
             REM skip out, look for next texture flag
             GOTO 1590
         END IF
       END IF
        REM
        REM ok, must be a texture here. read size of it and skip it
        GET #9, SFPOS + 21, SN
        TEXSIZE = CVL(MID$(SN, 1, 4))
        PRINT "Texture found, size of Texture = "; TEXSIZE
        FPOS = SFPOS + 21 + 12 + TEXSIZE
        REM
        REM check new jump. If zero, face info follows
        GET #9, FPOS, SN
        MYST = CVL(MID$(SN, 1, 4))
        A$ = HEX$(MYST)
        IF MYST = 0 THEN GOTO 1550
        REM
        REM Still here? could be a new texture. skip if so and check again
        IF A$ = "CDCDCDCD" THEN
            REM SKIP CD FILL AND PALETTE
            FPOS = FPOS + 4096 + 8192
            GET #9, FPOS, SN
            MYST = CVL(MID$(SN, 1, 4))
            A$ = HEX$(MYST)
        END IF
        REM
        REM check jump for 0 - if nothing this time, no faces.
        IF MYST = 0 THEN GOTO 1550
            REM NO FACES! JUMP TO NEXT TEXTURE
            PRINT "No faces this texture!"
            PRINT "JUMP POINTER READ FROM OFFSET "; FPOS - 1
            A$ = HEX$(MYST)
            PRINT "JUMP POINTER :"; A$
            GOTO 1590
        
1550    FACEPOS = FPOS + 16
        REM
        REM OK, whether after texture or not, ready to read no. of
        REM faces from offset FACEPOS
        REM
        PRINT "Texture "; S2; "..."
        PRINT "# OF FACES OFFSET = "; FACEPOS - 1
        GET #9, FACEPOS, SN
        NFACES = CVL(MID$(SN, 1, 4))
        PRINT "No. of FACES = "; NFACES
        
        REM
        REM face nodes...
        PRINT "Face nodes:"
        FOR IN = 1 TO NFACES
          FL = FACEPOS + 12 + (IN - 1) * 64
          GET #9, FL, FACES
          FOR IND = 1 TO 16
            FACENODES(IND) = CVL(MID$(FACES, 1 + (IND - 1) * 4, 4))
            PRINT FACENODES(IND);
            REM it's rough! but if we got it wrong, we'll be reading
            REM from a random part of the file...
            REM skip to resume scan if any of these node numbers is
            REM <0 or > no. of nodes in set
            IF IND <= 4 AND (FACENODES(IND) < -1 OR FACENODES(IND) > NNODES - 1) THEN
              PRINT "!!Warning... illegal node no.s... skipping"
              INPUT "Pause...", A$
              GOTO 1590
            END IF
          NEXT IND
          PRINT
          NTRIS = NTRIS + 1
          TRIS(NTRIS, 5) = NODESET
          REM PRINT TRIS(NTRIS, 5);
          PRINT
          REM
          REM ADD Prev. nodes to face node #s
          FOR IFN = 1 TO 4
              TRIS(NTRIS, IFN) = PREVNODES + FACENODES(IFN) + 1: REM OPTs start node no.s at 0
          NEXT IFN
          REM adjust for 3-sided faces
          IF TRIS(NTRIS, 4) <= PREVNODES THEN TRIS(NTRIS, 4) = TRIS(NTRIS, 1)
          REM debug
          IF NTRIS >= DISPFACE THEN
            CLS
            PRINT "face "; NTRIS; "nodeset "; NODESET; " ,nodes are ";
            FOR IFN = 1 TO 4: PRINT FACENODES(IFN); : NEXT IFN
            PRINT "co-ords are "
            FOR IFN = 1 TO 4
               FOR IFJ = 1 TO 3
                  PRINT NODES(TRIS(NTRIS, IFN), IFJ);
               NEXT IFJ
               PRINT
            NEXT IFN
          END IF
          IF NTRIS >= DISPFACE THEN GOSUB 2000
        NEXT IN
        REM
        REM Check link at end of face data
        FMPOS = FACEPOS + 12 + NFACES * 16 * 4 + NFACES * 3 * 4 + NFACES * 6 * 4
        GET #9, FMPOS, SN
        MYST = CVL(MID$(SN, 1, 4))
        A$ = HEX$(MYST)
        REM PRINT "Final Jump at offset "; FMPOS; ", jump bytes are "; A$

1590    REM IF NTRIS >= DISPFACE THEN GOSUB 2000
        REM IF S2 > "14" THEN GOSUB 2000
        REM PRINT
       
     SFPOS = SFPOS + 1
     GOTO 1520
1599 PRINT "NTRIS="; NTRIS
     RETURN

1900 REM
    REM TRANSFORM NODES (only if node exists-4th col=1)
    REM
    FOR I = 1 TO MAXNODES
    IF (NODES(I, 4) = 0) THEN GOTO 1950
      FOR J = 1 TO 4
        TNODES(I, J) = 0
        FOR K = 1 TO 4
          TNODES(I, J) = TNODES(I, J) + NODES(I, K) * TRANSMAT(K, J)
        NEXT K
      NEXT J
      FOR J = 1 TO 3
        TNODES(I, J) = TNODES(I, J) / TNODES(I, 4)
        IF TNODES(I, J) > MAX(J) THEN MAX(J) = TNODES(I, J)
        IF TNODES(I, J) < MIN(J) THEN MIN(J) = TNODES(I, J)
      NEXT J
1950 NEXT I
     RETURN


2000 REM
    REM draw on screen NTRIS tris
    SCREEN SMODE
    WINDOW (XWIN1, YWIN1)-(XWIN2, YWIN2)
    REM
    REM DRAW TRIS
    REM
    COLOUR = 7
    FOR I = 1 TO NTRIS
    REM
      IF I = NTRIS THEN COLOUR = 2
      LINE (TNODES(TRIS(I, 1), 1), TNODES(TRIS(I, 1), 2))-(TNODES(TRIS(I, 2), 1), TNODES(TRIS(I, 2), 2)), COLOUR
      LINE (TNODES(TRIS(I, 2), 1), TNODES(TRIS(I, 2), 2))-(TNODES(TRIS(I, 3), 1), TNODES(TRIS(I, 3), 2)), COLOUR
      LINE (TNODES(TRIS(I, 3), 1), TNODES(TRIS(I, 3), 2))-(TNODES(TRIS(I, 4), 1), TNODES(TRIS(I, 4), 2)), COLOUR
      LINE (TNODES(TRIS(I, 4), 1), TNODES(TRIS(I, 4), 2))-(TNODES(TRIS(I, 1), 1), TNODES(TRIS(I, 1), 2)), COLOUR

    NEXT I
    REM draw cross on last face
      LINE (TNODES(TRIS(NTRIS, 1), 1), TNODES(TRIS(NTRIS, 1), 2))-(TNODES(TRIS(NTRIS, 3), 1), TNODES(TRIS(NTRIS, 3), 2)), 1
      LINE (TNODES(TRIS(NTRIS, 2), 1), TNODES(TRIS(NTRIS, 2), 2))-(TNODES(TRIS(NTRIS, 4), 1), TNODES(TRIS(NTRIS, 4), 2)), 1
    SIDE = (XWIN2 - XWIN1) / 20
    LINE (XWIN2, YWIN2)-(XWIN2 - SIDE, YWIN2)
    LINE (XWIN2 - SIDE, YWIN2)-(XWIN2 - SIDE, YWIN2 - SIDE)
    LINE (XWIN2 - SIDE, YWIN2 - SIDE)-(XWIN2, YWIN2 - SIDE)
    LINE (XWIN2, YWIN2 - SIDE)-(XWIN2, YWIN2)
    LOCATE LASTROW, LASTCOL - 10: INPUT "PAUSE...", ANS$
    RETURN


2100 REM Set start and finish to read nodes
    GET #9, SFPOS, STR: REM Read no. of nodes
    PREVNODES = NNODES
    NNODES = CVL(MID$(STR, 1, 4))
    PRINT "No. of nodes this read = "; NNODES
    TNODES = NNODES + PREVNODES
    PRINT "TOTAL No. of nodes = "; TNODES
    REM INPUT "Pause..."; a$
    START = SFPOS + 8
    FINISH = START + NNODES * 3 * 4 - 1
    NNODES = TNODES
    RETURN



