10 REM VIEW
15 REM ====
20 REM Reads eyepoint & sightpoint from screen & writes them
30 REM to file VIEW.DAT, as well as the 4*4 transformation
40 REM matrix associated with the view.
50 REM (later) - also write screen window XWIN1,YWIN1,XWIN2,YWIN2
55 REM (even later) - also writes perspective (2 or 3 point) and eye angle
60 REM
70 DIM TRANSLATE(4, 4), ROTATE(4, 4), ROTATE1(4, 4), PROJECT(4, 4), TRANSMAT(4, 4)
80 DIM TEMP1(4, 4), TEMP2(4, 4)
90 DIM EYE(3), SIGHT(3), TRANSEYE(3)
100 REM
    CLS
    ON ERROR GOTO 110
    OPEN "VIEW.DAT" FOR INPUT AS #1
    INPUT #1, EYE(1), EYE(2), EYE(3)
    INPUT #1, SIGHT(1), SIGHT(2), SIGHT(3)
    PRINT "CURRENT EYEPOINT, SIGHTPOINT:"
    PRINT EYE(1), EYE(2), EYE(3)
    PRINT SIGHT(1), SIGHT(2), SIGHT(3)
    CLOSE
110 INPUT "GIVE EYEPOINT "; EYE(1), EYE(2), EYE(3)
120 INPUT "GIVE SIGHTPOINT "; SIGHT(1), SIGHT(2), SIGHT(3)
130 INPUT "3-POINT(3) OR 2-POINT(2) PERSPECTIVE ", P$
140 IF (P$ <> "2" AND P$ <> "3") THEN GOTO 130
150 SIGHTZ = SIGHT(3)
160 IF P$ = "2" THEN SIGHT(3) = EYE(3)
170 REM
180 REM INITIALISE MATRICES
190 REM
200 FOR I = 1 TO 4
210   FOR J = 1 TO 4
220     TRANSLATE(I, J) = 0
230     ROTATE(I, J) = 0
240     PROJECT(I, J) = 0
250   NEXT J
260   TRANSLATE(I, I) = 1
270   ROTATE(I, I) = 1
280   PROJECT(I, I) = 1
290 NEXT I
300 REM
310 REM ASSEMBLE TRANSLATION MATRIX
320 REM
330 FOR I = 1 TO 3
340   TRANSEYE(I) = EYE(I) - SIGHT(I)
350 NEXT I
360 FOR I = 1 TO 3
370   TRANSLATE(4, I) = -SIGHT(I)
380 NEXT I
390 REM
400 REM ASSEMBLE ROTATION MATRIX - ROTATE LINE 0,0,0 -> TRANSEYE TO
410 REM THE -ve Z AXIS. ROTATION AXIS IS CROSS PRODUCT OF TRANSEYE
420 REM POSITION VECTOR AND THE -ve Z AXIS.
430 REM
440 EYEDIST = SQR(TRANSEYE(1) ^ 2 + TRANSEYE(2) ^ 2 + TRANSEYE(3) ^ 2)
450 ROTAXIS(1) = -TRANSEYE(2)
460 ROTAXIS(2) = TRANSEYE(1)
470 ROTAXIS(3) = 0
480 ROTAXLEN = SQR(ROTAXIS(1) ^ 2 + ROTAXIS(2) ^ 2 + ROTAXIS(3) ^ 2)
490 C1 = ROTAXIS(1) / ROTAXLEN
500 C2 = ROTAXIS(2) / ROTAXLEN
510 C3 = ROTAXIS(3) / ROTAXLEN
520 COSA = -TRANSEYE(3) / EYEDIST
530 SINA = SQR(TRANSEYE(1) ^ 2 + TRANSEYE(2) ^ 2) / EYEDIST
540 GOSUB 1280
550 REM
560 REM INSERT IN ROTATE1
570 REM
580 FOR I = 1 TO 4
590   FOR J = 1 TO 4
600     ROTATE1(I, J) = ROTATE(I, J)
610     ROTATE(I, J) = 0
620   NEXT J
630   ROTATE(I, I) = 1
640 NEXT I
650 REM
660 REM  NOW ROTATE EYE X-AXIS TO SCREEN X-AXIS
670 REM
680 C1 = 0: C2 = 0: C3 = 1
690 COSA = ROTAXIS(1) / ROTAXLEN
700 SINA = -ROTAXIS(2) / ROTAXLEN
710 GOSUB 1280
720 REM
730 REM ASSEMBLE PROJECTION MATRIX, FLIP Y-CO-ORD
740 REM
750 PROJECT(3, 4) = 1 / EYEDIST
760 PROJECT(2, 2) = -1
770 REM
780 REM CONCATENATE TO SINGLE TRANSFORMATION MATRIX
790 REM
800 FOR I = 1 TO 4
810   FOR J = 1 TO 4
820     TEMP1(I, J) = 0
830     FOR K = 1 TO 4
840       TEMP1(I, J) = TEMP1(I, J) + TRANSLATE(I, K) * ROTATE1(K, J)
850     NEXT K
860   NEXT J
870 NEXT I
880 FOR I = 1 TO 4
890   FOR J = 1 TO 4
900     TEMP2(I, J) = 0
910     FOR K = 1 TO 4
920       TEMP2(I, J) = TEMP2(I, J) + TEMP1(I, K) * ROTATE(K, J)
930     NEXT K
940   NEXT J
950 NEXT I
960 FOR I = 1 TO 4
970   FOR J = 1 TO 4
980     TRANSMAT(I, J) = 0
990     FOR K = 1 TO 4
1000       TRANSMAT(I, J) = TRANSMAT(I, J) + TEMP2(I, K) * PROJECT(K, J)
1010     NEXT K
1020   NEXT J
1030 NEXT I
1040 REM
1050 REM WRITE MATRIX TO FILE
1060 REM
1070 SIGHT(3) = SIGHTZ
1080 OPEN "VIEW.DAT" FOR OUTPUT AS #1
1090 WRITE #1, EYE(1), EYE(2), EYE(3)
1100 WRITE #1, SIGHT(1), SIGHT(2), SIGHT(3)
1110 FOR I = 1 TO 4
1120   WRITE #1, TRANSMAT(I, 1), TRANSMAT(I, 2), TRANSMAT(I, 3), TRANSMAT(I, 4)
1130 NEXT I
1140 REM
1150 REM Calculate screen window and write to file - ENSURE 640*480 ASPECT RATIO
1160 REM
1170 INPUT "EYE ANGLE "; EYEANGLE
1180 EYEDIST = SQR((EYE(1) - SIGHT(1)) ^ 2 + (EYE(2) - SIGHT(2)) ^ 2 + (EYE(3) - SIGHT(3)) ^ 2)
1190 XWIN2 = EYEDIST * TAN(EYEANGLE / 2 * 3.1416 / 180): XWIN1 = -XWIN2
1200 YWIN2 = XWIN2 * 480 / 640: YWIN1 = -YWIN2
1210 IF P$ = "3" THEN GOTO 1240
1220 YWIN1 = YWIN1 - (EYE(3) - SIGHT(3))
1230 YWIN2 = YWIN2 - (EYE(3) - SIGHT(3))
1240 WRITE #1, XWIN1, YWIN1, XWIN2, YWIN2
1245 WRITE #1, P$
1247 WRITE #1, EYEANGLE
1250 CLOSE
1260 REM CHAIN "c:\PROGS\SURFACE"
1270 END
1280 ROTATE(1, 1) = C1 ^ 2 + (1 - C1 ^ 2) * COSA
1290 ROTATE(2, 2) = C2 ^ 2 + (1 - C2 ^ 2) * COSA
1300 ROTATE(3, 3) = C3 ^ 2 + (1 - C3 ^ 2) * COSA
1310 ROTATE(1, 2) = C1 * C2 * (1 - COSA) + C3 * SINA
1320 ROTATE(1, 3) = C1 * C3 * (1 - COSA) - C2 * SINA
1330 ROTATE(2, 1) = C1 * C2 * (1 - COSA) - C3 * SINA
1340 ROTATE(2, 3) = C2 * C3 * (1 - COSA) + C1 * SINA
1350 ROTATE(3, 1) = C1 * C3 * (1 - COSA) + C2 * SINA
1360 ROTATE(3, 2) = C2 * C3 * (1 - COSA) - C1 * SINA
1370 RETURN

